/**************************************************
 *
 * This is a template file.
 *
 * Copyright 1998 IAR Systems. All rights reserved.
 *
 * $Revision: 1.0 $
 *
 **************************************************/

/** include files **/
#include "i2c.h"

// Local functions prototype

// Local data

Boolean I2C1_Test (void)
{
I2C_InitTypeDef I2C_Struct;
GPIO_InitTypeDef GPIO_Struct;
Int32U to;
  /* Enable I2C0, I2C1 */
  I2C_Cmd (I2C1, ENABLE);

  /* Peripherals enable */
  SCU_APBPeriphClockConfig(__I2C1,ENABLE);
  I2C_DeInit(I2C1);
  SCU_APBPeriphClockConfig(__GPIO2, ENABLE);

  /* GPIO2 Config */
  GPIO_Struct.GPIO_Pin = GPIO_Pin_2 | GPIO_Pin_3  ;
  GPIO_Struct.GPIO_Type = GPIO_Type_OpenCollector;
  GPIO_Struct.GPIO_IPConnected = GPIO_IPConnected_Enable;
  GPIO_Struct.GPIO_Alternate=GPIO_OutputAlt2;
  GPIO_Init(GPIO2, &GPIO_Struct);

  /* I2C1 Configuration */
  I2C_Struct.I2C_GeneralCall = I2C_GeneralCall_Disable;
  I2C_Struct.I2C_Ack = I2C_Ack_Enable;
  I2C_Struct.I2C_CLKSpeed =100000;
  I2C_Struct.I2C_OwnAddress = 0xA0;
  I2C_Init(I2C1, &I2C_Struct);

  /* Send START condition */
  I2C_GenerateStart (I2C1, ENABLE);
  /* Test on EV5 and clear it */
  to = 1000;
  while( ! I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT) && --to);  // EV5
  if(to == 0)
  {
    return(1);
  }
  /* Send I2C1 Address for write */
  I2C_Send7bitAddress (I2C1, 0xA0, I2C_MODE_TRANSMITTER);
  for(to = 1000; to; to--);
  /* Test on EV6 and clear it */
  if(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECTED))  // EV6
  {
    return(1);
  }
  /* Generate STOP condition to close communication */
  I2C_GenerateSTOP (I2C1, ENABLE);
  /* Send START condition */
  I2C_GenerateStart (I2C1, ENABLE);
  /* Test on EV5 and clear it */
  to = 1000;
  while( ! I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT) && --to);  // EV5
  if(to == 0)
  {
    return(1);
  }
  /* Send I2C1 Address for write */
  I2C_Send7bitAddress (I2C1, 0xB0, I2C_MODE_TRANSMITTER);
  /* Test on EV6 and clear it */
  for(to = 1000; to; to--);
  if(I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECTED))  // EV6
  {
    return(1);
  }
  /* Generate STOP condition to close communication */
  I2C_GenerateSTOP (I2C1, ENABLE);
  return(0);
}
